// context menuitems
var elementTagsSelected = new Array('linky-selected-tab','linky-selected-win');
var elementTagsSelectedLink = new Array('linky-selected-link-tab','linky-selected-link-win');
var elementTagsAll = new Array('linky-all-tab','linky-all-win');
var elementTagsPictureAll = new Array('linky-pictures-tab','linky-pictures-win');
var elementTagsPictureLinks = new Array('linky-pictures-links-page-tab','linky-pictures-links-page-win');
var elementTagsPicturePage = new Array('linky-pictures-page-tab','linky-pictures-page-win');

// support functions
function getSelectionString() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	var selection = focusedWindow.__proto__.getSelection.call(focusedWindow);
	return String(selection);
}
function getSelectionObject() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	return focusedWindow.__proto__.getSelection.call(focusedWindow);
}
function linkySafe(lnk) {
	if (!lnk || lnk.substr(0,7) == "mailto:" || lnk.substr(0,11) == "javascript:") {
		return false;
	} else {
		return true;
	}
}
function replaceInsert(t, i, v) {
	var result = t;
	var re = new RegExp("#" + i);
	result = result.replace(re, v);
	return result;
}

// enables and disables the context menu
function linkyContext() {
	// set the tooltip to include the version and build numbers
	var msg = document.getElementById("bundle_linky").getString("linky-info-version");
	var re = /(.*)\.(.*?)$/;
	re.test(InstallTrigger.getVersion("linky"));
	// save the regexp since they get overwritten by the replace in replaceInsert
	var ver1 = RegExp.$1;
	var ver2 = RegExp.$2;
	msg = replaceInsert(msg, 1, ver1);
	msg = replaceInsert(msg, 2, ver2);
	document.getElementById("linky-info").setAttribute("tooltiptext",msg);

	// check for selection
	var disabled = "true";
	if (getSelectionString().length > 0) {
		if ("links" in document.commandDispatcher.focusedWindow.document) {
			if (document.commandDispatcher.focusedWindow.document.links.length != 0) {
				disabled = "false";
			}
		} else {
			// fallback
			disabled = "false";
		}
	}
	for (var i=0; i<elementTagsSelected.length; i++) {
		document.getElementById(elementTagsSelected[i]).setAttribute("disabled",disabled);
	}

	// check for link in selection
	disabled = "true";
	if (getSelectionString().length > 0) {
		var selection = getSelectionObject();
		var URL = /(\w*:\/\/\S+)/
		URL.test(selection);
		if (RegExp.$1) {
			disabled = "false";
		}
	}
	for (i=0; i<elementTagsSelectedLink.length; i++) {
		document.getElementById(elementTagsSelectedLink[i]).setAttribute("disabled",disabled);
	}

	// check for links
	disabled = "false";
	if ("links" in document.commandDispatcher.focusedWindow.document && document.commandDispatcher.focusedWindow.document.links.length < 1) {
		disabled = "true";
	}
	for (i=0; i<elementTagsAll.length; i++) {
		document.getElementById(elementTagsAll[i]).setAttribute("disabled",disabled);
	}

	// check for picture links
	disabled = "false";
	if ("links" in document.commandDispatcher.focusedWindow.document) {
		// update the info item with current numbers of links and images
		msg = document.getElementById("bundle_linky").getString("linky-info");
		msg = replaceInsert(msg, 1, document.commandDispatcher.focusedWindow.document.links.length);
		if ("images" in document.commandDispatcher.focusedWindow.document) {
			msg = replaceInsert(msg, 2, document.commandDispatcher.focusedWindow.document.images.length);
		} else {
			msg = replaceInsert(msg, 1, 0);
		}
		document.getElementById("linky-info").label = msg;

		// check for picture links
		if (document.commandDispatcher.focusedWindow.document.links.length != 0) {
			// because of performance only check the first 100 links
			if (document.commandDispatcher.focusedWindow.document.links.length > 100) {
				disabled = "false";
			} else {
				var lnks = document.commandDispatcher.focusedWindow.document.links;
				var reg = new RegExp("\.jpg|jpeg|gif|png$", "i");
				var found=0;
				for (i = 0; i < lnks.length; i++) {
					if (reg.test(lnks[i].href)) {
						found=1;
						break;
					}
				}
				if (found) {
					disabled = "false";
				} else {
					disabled = "true";
				}
			}
		} else {
			disabled = "true";
		}
	} else {
		document.getElementById("linky-info").label=document.getElementById("bundle_linky").getString("linky-info-na");
	}		
	for (i=0; i<elementTagsPictureAll.length; i++) {
		document.getElementById(elementTagsPictureAll[i]).setAttribute("disabled",disabled);
	}
	for (i=0; i<elementTagsPictureLinks.length; i++) {
		document.getElementById(elementTagsPictureLinks[i]).setAttribute("disabled",disabled);
	}

	// check for images on page
	disabled = "false";
	if ("images" in document.commandDispatcher.focusedWindow.document && document.commandDispatcher.focusedWindow.document.images.length < 1) {
		disabled = "true";
	}
	for (i=0; i<elementTagsPicturePage.length; i++) {
		document.getElementById(elementTagsPicturePage[i]).setAttribute("disabled",disabled);
	}
}

// opens all links inside a selection
function linkySelected(opentype) {
	if (getSelectionString().length < 1) {
		alert("Linky Error[0]: Selection is empty!");
	} else {
		if ("links" in document.commandDispatcher.focusedWindow.document) {
			var lnks = document.commandDispatcher.focusedWindow.document.links;
			if (lnks.length < 1) {
				alert("Linky Error[1]: No links in selection!");
			} else {
				var urls = new Array();
				var selection = getSelectionObject();
				for(var i = 0; i < lnks.length; ++i) {
					if (selection.containsNode(lnks[i], true)) {
						if (linkySafe(lnks[i].href)) {
							// check for dupe URLs
							var found = 0;
							for (var j = 0; j < urls.length; j++) {
								if (urls[j] == lnks[i].href || lnks[i] == document.commandDispatcher.focusedWindow.document.location.href) {
									found = 1;
									break;
								}
							}
							if (!found) {
								openLink(lnks[i].href, opentype);
								urls[urls.length] = lnks[i].href;
							}
						}
					}
				}
			}
		} else {
			alert("Linky Error[2]: Cant access links in document!");
		}
	}
}

// opens text link inside a selection
function linkySelectedLink(opentype) {
	if (getSelectionString().length < 1) {
		alert("Linky Error[3]: Selection is empty!");
	} else {
		var selection = getSelectionObject();
		var URL = /(\w*:\/\/\S+)/
		URL.test(selection);
		if (RegExp.$1) {
			openLink(RegExp.$1, opentype);
		} else {
			alert("Linky Error[4]: No link found in selection!");
		}
	}
}

// Show all images on one page
function linkyImages(opentype) {
	if ("images" in document.commandDispatcher.focusedWindow.document) {
		var imgs = document.commandDispatcher.focusedWindow.document.images;
		var doc;
		var docopen;
		var urls = new Array();
		for (var i = 0; i < imgs.length; i++) {
			if (imgs[i].src) {
				var found = 0;
				for (var j = 0; j < urls.length; j++) {
					if (urls[j] == imgs[i].src) {
						found = 1;
						break;
					}
				}
				if (!found) {
					if (docopen != 1) {
						var docnew;
						if (opentype == 1) {
							var tmp = gBrowser.getBrowserForTab(gBrowser.addTab());
							doc = tmp.contentDocument;
							docopen = 1;
						} else if (opentype == 2) {
							doc = document.commandDispatcher.focusedWindow.open("about:blank").document;
							docopen = 1;
						} else {
							alert("Linky Error[5]: Unknown opentype: " + opentype);
							break;
						}
					}
					openLink(imgs[i].src, 3, doc);
					urls[urls.length] = imgs[i].src;
				}
			}
		}
		// have to close document to actual see the page
		if (docopen == 1) {
			doc.close();
		}
	} else {
		alert("Linky Error[6]: Cant access images in document!");
	}
}

// Open all links
function linkyAll(opentype) {
	if ("links" in document.commandDispatcher.focusedWindow.document) {
		var lnks = document.commandDispatcher.focusedWindow.document.links;
		var urls = new Array();
		var doc;
		var docopen;
		for (var i = 0; i < lnks.length; i++) {
			if (linkySafe(lnks[i].href)) {
				var found = 0;
				for (var j = 0; j < urls.length; j++) {
					if (urls[j] == lnks[i].href || lnks[i] == document.commandDispatcher.focusedWindow.document.location.href) {
						found = 1;
						break;
					}
				}
				if (!found) {
					if (opentype == 1) {
						openLink(lnks[i].href, 1);
						urls[urls.length] = lnks[i].href;
					} else if (opentype == 2) {
						openLink(lnks[i].href, 2);
						urls[urls.length] = lnks[i].href;
					} else if (opentype == 3 || opentype == 4 || opentype == 5 || opentype == 6) {
						var reg = new RegExp("\.jpg|jpeg|gif|png$", "i");
						if (reg.test(lnks[i].href)) {
							if (opentype == 3) {
								openLink(lnks[i].href, 1);
								urls[urls.length] = lnks[i].href;
							} else if (opentype == 4) {
								openLink(lnks[i].href, 2);
								urls[urls.length] = lnks[i].href;
							} else if (opentype == 5) {
								if (docopen != 1) {
									var tmp = gBrowser.getBrowserForTab(gBrowser.addTab());
									doc = tmp.contentDocument;
									docopen = 1;
								}
								openLink(lnks[i].href, 3, doc);
								urls[urls.length] = lnks[i].href;
							} else if (opentype == 6) {
								if (docopen != 1) {
									doc = document.commandDispatcher.focusedWindow.open("about:blank").document;
									docopen = 1;
								}
								openLink(lnks[i].href, 3, doc);
								urls[urls.length] = lnks[i].href;
							} else {
								alert("Linky Error[8]: Unknown opentype: " + opentype);
							}
						}
					} else {
						alert("Linky Error[9]: Unknown opentype: " + opentype);
						return;
					}
				}
			}
		}
	} else {
		alert("Linky Error[10]: Cant access links in document!");
	}
	// have to close document to actual see the page
	if (docopen == 1) {
		doc.close();
	}
}

// go home
function linkyHome() {
	document.commandDispatcher.focusedWindow.open("http://linky.mozdev.org");
}

// opens a link is either a new tab or a new window
function openLink(lnk,typ,doc) {
	if (typ == 1) {
		getBrowser().addTab(lnk, getReferrer(document));
	} else if (typ == 2) {
		document.commandDispatcher.focusedWindow.open(lnk);
	} else if (typ == 3) {
		if (!doc) {
			alert("Linky Error[11]: Document is undefined!");
		} else {
			doc.writeln('<img src="' + lnk + '" alt="' + lnk + '" title="' + lnk + '">');
		}
	} else {
		alert("Linky Error[12]: Unknown typ: " + typ);
	}
}